Project Chrono: chrono::vehicle::ChDeformableTire Class Reference

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChDeformableTire Class Referenceabstract
VEHICLE module » Wheeled vehicles » Tire subsystem

## Description

Base class for a deformable tire model.

`#include <ChDeformableTire.h>`

Inheritance diagram for chrono::vehicle::ChDeformableTire:
[legend]
Collaboration diagram for chrono::vehicle::ChDeformableTire:
[legend]

## Public Types
enum class | ContactSurfaceType { NODE_CLOUD , TRIANGLE_MESH }
| Type of the mesh contact surface.
Public Types inherited from chrono::vehicle::ChTire
enum class | CollisionType { SINGLE_POINT , FOUR_POINTS , ENVELOPE }

## Public Member Functions
| ChDeformableTire (const std::string &name)
| Construct a deformable tire with the specified name.
virtual double | GetTireMass () const override final
| Return the tire mass.
virtual ChVector3d | GetTireInertia () const override final
| Return the tire moments of inertia (in the tire centroidal frame).
void | SetContactSurfaceType (ContactSurfaceType type)
| Set the type of contact surface.
ContactSurfaceType | GetContactSurfaceType () const
void | SetContactNodeRadius (double radius)
| Set radius of contact nodes.
double | GetContactNodeRadius () const
void | SetContactFaceThickness (double thickness)
| Set thickness of contact faces (radius of swept sphere).
double | GetContactFaceThickness () const
std::shared_ptr< ChContactMaterialSMC > | GetContactMaterial () const
| Get the tire contact material.
void | EnablePressure (bool val)
| Enable/disable tire pressure (default: true).
bool | IsPressureEnabled () const
void | EnableContact (bool val)
| Enable/disable tire contact (default: true).
bool | IsContactEnabled () const
void | EnableRimConnection (bool val)
| Enable/disable tire-rim connection (default: true).
bool | IsRimConnectionEnabled () const
ChVisualShapeFEA * | GetMeshVisualization () const
| Get a handle to the mesh visualization.
std::shared_ptr< fea::ChMesh > | GetMesh () const
| Get the underlying FEA mesh.
std::shared_ptr< fea::ChContactSurface > | GetContactSurface () const
| Get the mesh contact surface.
std::shared_ptr< ChLoadContainer > | GetLoadContainer () const
| Get the load container associated with this tire.
virtual double | GetRimRadius () const =0
| Get the rim radius (inner tire radius).
virtual TerrainForce | ReportTireForce (ChTerrain *terrain) const override
| Report the tire force and moment.
virtual TerrainForce | ReportTireForceLocal (ChTerrain *terrain, ChCoordsys<> &tire_frame) const override
| Get the tire force and moment expressed in the tire frame.
virtual void | AddVisualizationAssets (VisualizationType vis) override final
| Add visualization assets for the rigid tire subsystem.
virtual void | RemoveVisualizationAssets () override final
| Remove visualization assets for the rigid tire subsystem.
Public Member Functions inherited from chrono::vehicle::ChTire
void | SetStepsize (double val)
| Set the value of the integration step size for the underlying dynamics (if applicable).
double | GetStepsize () const
| Get the current value of the integration step size.
void | SetCollisionType (CollisionType collision_type)
| Set the collision type for tire-terrain interaction.
void | SetPressure (double pressure)
| Set the internal tire pressure [Pa].
double | GetPressure () const
| Get the internal tire pressure [Pa].
virtual double | GetRadius () const =0
| Get the tire radius.
virtual double | GetWidth () const =0
| Get the tire width.
double | GetSlipAngle () const
| Return the tire slip angle calculated based on the current state of the associated wheel body.
double | GetLongitudinalSlip () const
| Return the tire longitudinal slip calculated based on the current state of the associated wheel body.
double | GetCamberAngle () const
| Return the tire camber angle calculated based on the current state of the associated wheel body.
virtual double | GetDeflection () const
| Report the tire deflection.
const std::string & | GetMeshFilename () const
| Get the name of the Wavefront file with tire visualization mesh.
virtual void | Synchronize (double time, const ChTerrain &terrain)
| Update the state of this tire system at the current time.
virtual void | Advance (double step)
| Advance the state of this tire by the specified time step.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
virtual std::string | GetTemplateName () const =0
| Get the name of the vehicle subsystem template.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Protected Member Functions
virtual double | GetDefaultPressure () const =0
| Return the default tire pressure.
virtual std::vector< std::shared_ptr< fea::ChNodeFEAbase > > | GetConnectedNodes () const =0
| Return list of nodes connected to the rim.
virtual void | CreateMesh (const ChFrameMoving<> &wheel_frame, VehicleSide side)=0
| Create the FEA nodes and elements.
virtual void | CreatePressureLoad ()=0
| Create the ChLoad for applying pressure to the tire.
virtual void | CreateContactSurface ()=0
| Create the contact surface for the tire mesh.
virtual void | CreateRimConnections (std::shared_ptr< ChBody > wheel)=0
| Create the tire-rim connections.
virtual void | CreateContactMaterial ()=0
| Create the SMC contact material.
virtual double | GetAddedMass () const override final
| Get the mass added to the associated spindle body.
virtual ChVector3d | GetAddedInertia () const override final
| Get the inertia added to the associated spindle body.
virtual void | InitializeInertiaProperties () override final
| Return the tire mass.
virtual void | UpdateInertiaProperties () override final
| Return the tire moments of inertia (in the tire centroidal frame).
virtual void | Initialize (std::shared_ptr< ChWheel > wheel) override
| Initialize this tire by associating it to the specified wheel.
virtual TerrainForce | GetTireForce () const override final
| Get the tire force and moment.
Protected Member Functions inherited from chrono::vehicle::ChTire
| ChTire (const std::string &name)
| Construct a tire subsystem with given name.
void | CalculateKinematics (const WheelState &wheel_state, const ChCoordsys<> &tire_frame)
| Calculate kinematics quantities based on the given state of the associated wheel body.
double | GetOffset () const
| Get offset from spindle center.
std::shared_ptr< ChVisualShapeTriangleMesh > | AddVisualizationMesh (const std::string &mesh_file_left, const std::string &mesh_file_right)
| Add mesh visualization to the body associated with this tire (a wheel spindle body).
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< fea::ChMesh > | m_mesh
| tire mesh
std::shared_ptr< ChLoadContainer > | m_load_container
| load container (for pressure load)
std::vector< std::shared_ptr< fea::ChLinkNodeFrame > > | m_connections
| tire-wheel point connections
std::vector< std::shared_ptr< fea::ChLinkNodeSlopeFrame > > | m_connectionsD
| tire-wheel direction connections
std::vector< std::shared_ptr< ChLinkMateFix > > | m_connectionsF
| tire-wheel fix connection (point+rotation)
bool | m_connection_enabled
| enable tire connections to rim
bool | m_pressure_enabled
| enable internal tire pressure
bool | m_contact_enabled
| enable tire-terrain contact
ContactSurfaceType | m_contact_type
| type of contact surface model (node cloud or mesh)
double | m_contact_node_radius
| node radius (for node cloud contact surface)
double | m_contact_face_thickness
| face thickness (for mesh contact surface)
std::shared_ptr< ChContactMaterialSMC > | m_contact_mat
| tire contact material
std::shared_ptr< ChVisualShapeFEA > | m_visualization
| tire mesh visualization
Protected Attributes inherited from chrono::vehicle::ChTire
std::shared_ptr< ChWheel > | m_wheel
| associated wheel subsystem
double | m_stepsize
| tire integration step size (if applicable)
double | m_pressure
| internal tire pressure
CollisionType | m_collision_type
| method used for tire-terrain collision
std::string | m_vis_mesh_file
| name of OBJ file for visualization of this tire (may be empty)
double | m_slip_angle
double | m_longitudinal_slip
double | m_camber_angle
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChTire
static ChVector3d | EstimateInertia (double tire_width, double aspect_ratio, double rim_diameter, double tire_mass, double t_factor=2)
| Utility function for estimating the tire moments of inertia.
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChTire
static bool | DiscTerrainCollision (CollisionType method, const ChTerrain &terrain, const ChVector3d &disc_center, const ChVector3d &disc_normal, double disc_radius, double width, const ChFunctionInterp &areaDep, ChCoordsys<> &contact, double &depth, float &mu)
| Perform disc-terrain collision detection, using the specified method.
static void | ConstructAreaDepthTable (double disc_radius, ChFunctionInterp &areaDep)
| Utility function to construct a loopkup table for penetration depth as function of intersection area, for a given tire radius.
static bool | DiscTerrainCollision1pt (const ChTerrain &terrain, const ChVector3d &disc_center, const ChVector3d &disc_normal, double disc_radius, ChCoordsys<> &contact, double &depth, float &mu)
| Perform disc-terrain collision detection.
static bool | DiscTerrainCollision4pt (const ChTerrain &terrain, const ChVector3d &disc_center, const ChVector3d &disc_normal, double disc_radius, double width, ChCoordsys<> &contact, double &depth, float &mu)
| Perform disc-terrain collision detection considering the curvature of the road surface.
static bool | DiscTerrainCollisionEnvelope (const ChTerrain &terrain, const ChVector3d &disc_center, const ChVector3d &disc_normal, double disc_radius, double width, const ChFunctionInterp &areaDep, ChCoordsys<> &contact, double &depth, float &mu)
| Collsion algorithm based on a paper of J.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChDeformableTire::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| finaloverridevirtual

Add visualization assets for the rigid tire subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ CreateContactSurface()

virtual void chrono::vehicle::ChDeformableTire::CreateContactSurface | ( |  | ) |
| protectedpure virtual

Create the contact surface for the tire mesh.

A derived class must create a contact surface and add it to the underlying mesh.

Implemented in chrono::vehicle::ChANCFTire, chrono::vehicle::ChFEATire, and chrono::vehicle::ChReissnerTire.

## ◆ CreateMesh()

virtual void chrono::vehicle::ChDeformableTire::CreateMesh | ( | const ChFrameMoving<> & | wheel_frame,
|  | VehicleSide | side )
| protectedpure virtual

Create the FEA nodes and elements.

The wheel rotational axis is assumed to be the Y axis.

Parameters

  [in] | wheel_frame | frame of associated wheel
  [in] | side | left/right vehicle side

Implemented in chrono::vehicle::ANCFTire, chrono::vehicle::FEATire, chrono::vehicle::hmmwv::HMMWV_ANCFTire, chrono::vehicle::hmmwv::HMMWV_ReissnerTire, and chrono::vehicle::ReissnerTire.

## ◆ CreatePressureLoad()

virtual void chrono::vehicle::ChDeformableTire::CreatePressureLoad | ( |  | ) |
| protectedpure virtual

Create the ChLoad for applying pressure to the tire.

A derived class must create a load and add it to the underlying load container.

Implemented in chrono::vehicle::ChANCFTire, chrono::vehicle::ChFEATire, and chrono::vehicle::ChReissnerTire.

## ◆ CreateRimConnections()

virtual void chrono::vehicle::ChDeformableTire::CreateRimConnections | ( | std::shared_ptr< ChBody > | wheel | ) |
| protectedpure virtual

Create the tire-rim connections.

A derived class must create the various constraints between the tire and the provided wheel body and add them to the underlying system.

Parameters

  [in] | wheel | associated wheel body

Implemented in chrono::vehicle::ChANCFTire, chrono::vehicle::ChFEATire, and chrono::vehicle::ChReissnerTire.

## ◆ GetAddedInertia()

virtual ChVector3d chrono::vehicle::ChDeformableTire::GetAddedInertia | ( |  | ) | const
| inlinefinaloverrideprotectedvirtual

Get the inertia added to the associated spindle body.

Certain tires (e.g., those FEA-based) have their own physical representation and hence do not add mass and inertia to the spindle body. All others increment the spindle body moments of inertia by the amount reported by this function.

Implements chrono::vehicle::ChTire.

## ◆ GetAddedMass()

virtual double chrono::vehicle::ChDeformableTire::GetAddedMass | ( |  | ) | const
| inlinefinaloverrideprotectedvirtual

Get the mass added to the associated spindle body.

Certain tires (e.g., those FEA-based) have their own physical representation and hence do not add mass and inertia to the spindle body. All others increment the spindle body mass by the amount repoirted by this function.

Implements chrono::vehicle::ChTire.

## ◆ GetConnectedNodes()

virtual std::vector< std::shared_ptr< fea::ChNodeFEAbase > > chrono::vehicle::ChDeformableTire::GetConnectedNodes | ( |  | ) | const
| protectedpure virtual

Return list of nodes connected to the rim.

Implemented in chrono::vehicle::ANCFTire, chrono::vehicle::FEATire, chrono::vehicle::hmmwv::HMMWV_ANCFTire, chrono::vehicle::hmmwv::HMMWV_ReissnerTire, and chrono::vehicle::ReissnerTire.

## ◆ GetContactMaterial()

std::shared_ptr< ChContactMaterialSMC > chrono::vehicle::ChDeformableTire::GetContactMaterial | ( |  | ) | const
| inline

Get the tire contact material.

Note that this is not set until after tire initialization.

## ◆ GetContactSurface()

std::shared_ptr< ChContactSurface > chrono::vehicle::ChDeformableTire::GetContactSurface | ( |  | ) | const

Get the mesh contact surface.

If contact is not enabled, an empty shared pointer is returned.

## ◆ GetDefaultPressure()

virtual double chrono::vehicle::ChDeformableTire::GetDefaultPressure | ( |  | ) | const
| protectedpure virtual

Return the default tire pressure.

Implemented in chrono::vehicle::ANCFTire, chrono::vehicle::FEATire, chrono::vehicle::hmmwv::HMMWV_ANCFTire, chrono::vehicle::hmmwv::HMMWV_ReissnerTire, and chrono::vehicle::ReissnerTire.

## ◆ GetRimRadius()

virtual double chrono::vehicle::ChDeformableTire::GetRimRadius | ( |  | ) | const
| pure virtual

Get the rim radius (inner tire radius).

Implemented in chrono::vehicle::ANCFTire, chrono::vehicle::FEATire, chrono::vehicle::hmmwv::HMMWV_ANCFTire, chrono::vehicle::hmmwv::HMMWV_ReissnerTire, and chrono::vehicle::ReissnerTire.

## ◆ GetTireForce()

TerrainForce chrono::vehicle::ChDeformableTire::GetTireForce | ( |  | ) | const
| finaloverrideprotectedvirtual

Get the tire force and moment.

A ChDeformableTire always returns zero forces and moments since tire forces are implicitly applied to the associated wheel through the tire-wheel connections.

Implements chrono::vehicle::ChTire.

## ◆ GetTireInertia()

ChVector3d chrono::vehicle::ChDeformableTire::GetTireInertia | ( |  | ) | const
| finaloverridevirtual

Return the tire moments of inertia (in the tire centroidal frame).

Implements chrono::vehicle::ChTire.

## ◆ GetTireMass()

double chrono::vehicle::ChDeformableTire::GetTireMass | ( |  | ) | const
| finaloverridevirtual

Return the tire mass.

Implements chrono::vehicle::ChTire.

## ◆ Initialize()

void chrono::vehicle::ChDeformableTire::Initialize | ( | std::shared_ptr< ChWheel > | wheel | ) |
| overrideprotectedvirtual

Initialize this tire by associating it to the specified wheel.

Reimplemented from chrono::vehicle::ChTire.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChDeformableTire::InitializeInertiaProperties | ( |  | ) |
| finaloverrideprotectedvirtual

Return the tire mass.

Implements chrono::vehicle::ChPart.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChDeformableTire::RemoveVisualizationAssets | ( |  | ) |
| finaloverridevirtual

Remove visualization assets for the rigid tire subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ ReportTireForce()

TerrainForce chrono::vehicle::ChDeformableTire::ReportTireForce | ( | ChTerrain * | terrain | ) | const
| overridevirtual

Report the tire force and moment.

This generalized force encapsulates the tire-terrain forces, as well as the weight of the tire itself and is calculated as the resultant of all reaction forces and torques in the tire-wheel connections, as applied at the wheel body center of mass. The force and moment are expressed in the global frame.

Implements chrono::vehicle::ChTire.

## ◆ ReportTireForceLocal()

TerrainForce chrono::vehicle::ChDeformableTire::ReportTireForceLocal | ( | ChTerrain * | terrain,
|  | ChCoordsys<> & | tire_frame ) const
| overridevirtual

Get the tire force and moment expressed in the tire frame.

Currently NOT IMPLEMENTED.

Implements chrono::vehicle::ChTire.

## ◆ SetContactFaceThickness()

void chrono::vehicle::ChDeformableTire::SetContactFaceThickness | ( | double | thickness | ) |
| inline

Set thickness of contact faces (radius of swept sphere).

This value is relevant only for TRIANGLE_MESH contact surface type.

## ◆ SetContactNodeRadius()

void chrono::vehicle::ChDeformableTire::SetContactNodeRadius | ( | double | radius | ) |
| inline

Set radius of contact nodes.

This value is relevant only for NODE_CLOUD contact surface type.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChDeformableTire::UpdateInertiaProperties | ( |  | ) |
| finaloverrideprotectedvirtual

Return the tire moments of inertia (in the tire centroidal frame).

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/tire/ChDeformableTire.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/tire/ChDeformableTire.cpp